// DO NOT EDIT
//   Generated from javascripts/dashboard/profile.coffee
//
(function() {
  var addFriendButton, addFriendContainer, bindLoadMoreEvent, bindPostMessageEvent, friendsBadgeNode, friendsNode, friendsSubtitleNode, gamesNode, gamesSubtitleNode, headerNode, headerTitleNode, infoCellNode, isLocalUser, loadMoreNode, newMessageNode, pendingFriendContainer, postMessageFormNode, postMessageNode, postNode, statusNode, updateBasicInfo, updateGameFriendInfo, updateStatusContainerNode, updateStatusNode, updateWallInfo, useNameNode, userProfilePictureNode, userScoreNode, wallMessageTmpl;
  OF.page.user = OF.page.params.user || {
    id: OF.page.params.user_id
  };
  isLocalUser = parseInt(OF.page.user.id) === parseInt(OF.user.id);
  headerNode = $('#header');
  headerTitleNode = headerNode.find('.title');
  infoCellNode = $('#info_cell');
  useNameNode = $('.user_name');
  userScoreNode = infoCellNode.find('.user_score');
  userProfilePictureNode = infoCellNode.find('.avatar');
  statusNode = $('#status');
  updateStatusNode = $('#update_status');
  updateStatusContainerNode = $('.status_container');
  addFriendContainer = $('#add_friend');
  addFriendButton = addFriendContainer.find('.action_button');
  pendingFriendContainer = $('#pending_friend');
  gamesNode = $('#games');
  gamesSubtitleNode = gamesNode.find('.subtitle');
  friendsNode = $('#friends');
  friendsSubtitleNode = friendsNode.find('.subtitle');
  friendsBadgeNode = $('#pending_friends');
  postMessageNode = $('#post_message');
  postMessageFormNode = postMessageNode.find('form');
  postNode = $('#post');
  newMessageNode = $('#new_message');
  loadMoreNode = $('#load_more');
  wallMessageTmpl = tmpl('message_tmpl');
  if (isLocalUser) {
    OF.page.title = 'My Profile';
    updateStatusNode.unhide();
    updateStatusContainerNode.touch(function() {
      return OF.push('dashboard/statusupdate');
    });
    addFriendContainer.addClass('hidden');
    pendingFriendContainer.addClass('hidden');
  } else {
    OF.page.title = 'Feint Friends';
    updateStatusNode.addClass('hidden');
    OF.api('/xp/friends/status', {
      background: true,
      method: 'GET',
      params: {
        id: OF.page.user.id
      },
      success: function(data) {
        var status;
        status = data.friendship.status;
        if (status === 'friends') {
          addFriendContainer.addClass('hidden');
          return pendingFriendContainer.addClass('hidden');
        } else if (status === 'unrelated') {
          addFriendContainer.unhide();
          return pendingFriendContainer.addClass('hidden');
        } else {
          addFriendContainer.addClass('hidden');
          return pendingFriendContainer.unhide();
        }
      }
    });
    addFriendButton.touch(function() {
      OF.GA.page('/webui/dashboard/profile_addFriend');
      OF.api('/xp/friend_requests', {
        background: true,
        method: 'POST',
        params: {
          friend_id: OF.page.user.id
        }
      });
      addFriendContainer.addClass('hidden');
      return pendingFriendContainer.unhide();
    });
  }
  updateBasicInfo = function() {
    useNameNode.html(OF.page.user.name);
    userScoreNode.html(OF.page.user.gamer_score);
    userScoreNode.unhide();
    if (OF.page.user.profile_picture_url != null) {
      return userProfilePictureNode.css('background-image', "url(" + OF.page.user.profile_picture_url + ")");
    }
  };
  OF.page.updateStatusInfo = function(status) {
    if (status != null) {
      statusNode.parent().removeClass('hidden');
    }
    return statusNode.html(status);
  };
  updateGameFriendInfo = function() {
    var friendNum, friendString, gameNum, gameString, pendingNum;
    gameNum = OF.page.user.games_count;
    gameString = gameNum <= 1 ? 'Game' : 'Games';
    gamesSubtitleNode.html("" + gameNum + " " + gameString);
    friendNum = OF.page.user.friendship_count;
    friendString = friendNum <= 1 ? 'Friend' : 'Friends';
    friendsSubtitleNode.html("" + friendNum + " " + friendString);
    if (isLocalUser) {
      pendingNum = OF.page.user.received_friend_requests_pending_count;
      if (pendingNum > 999) {
        pendingNum = 999;
      }
      if (pendingNum > 0) {
        friendsBadgeNode.html(pendingNum);
        return friendsBadgeNode.unhide();
      } else {
        friendsBadgeNode.html('');
        return friendsBadgeNode.addClass('hidden');
      }
    }
  };
  updateWallInfo = function(wallMessages, newItemNum, flagNode) {
    var currentNode, deleteNode, newMessagesHTML, notProcessNode, notProcessNodes, usernameNode, wallMessage, _i, _j, _len, _len2, _results;
    newMessagesHTML = '';
    for (_i = 0, _len = wallMessages.length; _i < _len; _i++) {
      wallMessage = wallMessages[_i];
      if (wallMessage.profile_picture_url) {
        wallMessage.style = "background-image: url(" + wallMessage.profile_picture_url + ")";
      } else {
        wallMessage.style = '';
      }
      wallMessage.data_href = "data-href='dashboard/profile?user_id=" + wallMessage.user_id + "'";
      newMessagesHTML += wallMessageTmpl(wallMessage);
    }
    flagNode.after(newMessagesHTML);
    $('li.new_message').removeClass('new_message');
    notProcessNodes = $('li.not_process');
    _results = [];
    for (_j = 0, _len2 = notProcessNodes.length; _j < _len2; _j++) {
      notProcessNode = notProcessNodes[_j];
      currentNode = $(notProcessNode);
      deleteNode = currentNode.find('div.message_action');
      usernameNode = currentNode.find('p.username');
      if (isLocalUser || OF.user.id === usernameNode.data('userid')) {
        deleteNode.unhide();
      }
      if (isLocalUser) {
        if (newItemNum > 0) {
          currentNode.addClass('new_message');
          newItemNum--;
        }
      }
      _results.push(currentNode.unhide().removeClass('not_process'));
    }
    return _results;
  };
  bindLoadMoreEvent = function() {
    return loadMoreNode.touch(function() {
      var lastMessageNode, messageContentNode, requestData;
      OF.GA.page('/webui/dashboard/profile_loadMoreMessage');
      lastMessageNode = $('li.message:last');
      messageContentNode = lastMessageNode.find('.center_column');
      requestData = {
        method: 'GET',
        params: {
          last_item_id: messageContentNode.data('id'),
          wall_id: OF.page.user.wall_id
        },
        success: function(data) {
          if (data.wall_items.length < 10) {
            loadMoreNode.addClass('hidden');
          }
          return updateWallInfo(data.wall_items, 0, lastMessageNode);
        },
        failure: function() {
          return OF.alert('Oops', 'Oops! An error has occured.');
        }
      };
      return OF.api.request('/xp/wall/items/more', requestData);
    });
  };
  bindPostMessageEvent = function() {
    postMessageFormNode.submit(function() {
      var firstMessageNode, messageContentNode, newMessage, requestData;
      newMessage = $.trim(newMessageNode.val());
      if (newMessage.length > 0) {
        newMessage = newMessage.replace(/</gi, "&lt;").replace(/>/gi, "&gt;");
        OF.GA.page('/webui/dashboard/profile_postComment');
        firstMessageNode = $('li.message:first');
        messageContentNode = firstMessageNode.find('.center_column');
        requestData = {
          method: 'POST',
          params: {
            status_message: {
              body: newMessage,
              wall_id: OF.page.user.wall_id
            },
            last_item_id: messageContentNode.data('id')
          },
          success: function(data) {
            updateWallInfo(data.wall_items, data.wall_items.length, postMessageNode);
            return newMessageNode.val('');
          },
          failure: function() {
            return OF.alert('Oops', 'Oops! An error has occured.');
          }
        };
        OF.api.request('/xp/status_messages', requestData);
      } else {
        OF.alert('Missing Data', 'You haven\'t input anything to update yet.');
      }
      return false;
    });
    return postNode.touch(function() {
      return postMessageFormNode.submit();
    });
  };
  OF.api("/xp/users/" + OF.page.user.id + "/profile", {
    success: function(data) {
      var currentStatus;
      OF.page.user = data.user;
      currentStatus = OF.page.user.status;
      if (isLocalUser) {
        OF.user = OF.page.user;
        if (!(OF.page.user.status != null)) {
          currentStatus = 'What are you up to?';
        }
      }
      if (OF.user.has_set_name) {
        postMessageNode.unhide();
      } else {
        OF.confirm('', 'You need to set your own feint name in order to post on wall', 'Ok', 'Cancel', function() {
          return OF.push('settings/profile_configuration', {
            params: {
              back_url: "dashboard/profile?user_id=" + OF.page.user.id
            }
          });
        });
      }
      updateBasicInfo();
      OF.page.updateStatusInfo(currentStatus);
      updateGameFriendInfo();
      if (OF.page.user.wall_items.length === 10) {
        loadMoreNode.unhide();
      }
      updateWallInfo(OF.page.user.wall_items, OF.page.user.not_viewed_wall_items_count, postMessageNode);
      bindLoadMoreEvent();
      return bindPostMessageEvent();
    }
  });
  $('#games').touch(function() {
    return OF.push('dashboard/games', {
      params: {
        user_id: OF.page.user.id,
        user_name: OF.page.user.name
      }
    });
  });
  $('#friends').touch(function() {
    if (isLocalUser) {
      return OF.push('dashboard/me/friends');
    } else {
      return OF.push('dashboard/friends', {
        params: {
          user: OF.page.user
        }
      });
    }
  });
  $('.delete_message').touch(function() {
    var messageNode;
    messageNode = $(this).parents('.message');
    return OF.confirm('', 'Do you really want to delete this item?', 'Yes', 'No', function() {
      var messageContentNode, requestData;
      messageContentNode = messageNode.find('.center_column');
      requestData = {
        method: 'DELETE',
        success: function() {
          return messageNode.remove();
        },
        failure: function() {
          return OF.alert('Oops', 'Oops! An error has occured.');
        }
      };
      return OF.api.request("/xp/wall/items/" + (messageContentNode.data('id')), requestData);
    });
  });
}).call(this);
